package com.tomlost.MSSQL;
import java.sql.Connection;
import java.sql.Driver;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;

import java.lang.*;
import java.sql.*;

import android.widget.Toast;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.BA.Permissions;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;

@ShortName("MYSQL")
@Permissions(values={"android.permission.INTERNET","android.permission.ACCESS_NETWORK_STATE"})
@Version((float) 1.01)
@DependsOn(values={"mysql-connector-java-5.1.22-bin"})
public class MYSQL {
	private String pIPAddress,pDatabaseName,pUserName,pPassword;
	ResultSetMetaData metaData;
	int columnCount = 0, otoID = 1;
	String url, driver;
	ArrayList<String> arrayTablolar = new ArrayList<String>();
	ArrayList<ArrayList<String>> arrayResults = new ArrayList<ArrayList<String>>();
	
	
	public void setDatabase(String IPAddress,String DatabaseName,String UserName,String Password)
	{
		pIPAddress = IPAddress;
		pDatabaseName = DatabaseName;
		pUserName = UserName;
		pPassword = Password;
		url = "jdbc:mysql://" + pIPAddress + "/"+pDatabaseName + "";
		driver = "com.mysql.jdbc.Driver";
	}
	
	public ArrayList<ArrayList<String>> Query(String Sql)
	{
		try
		{
		ResultSet rs = QueryExecute(Sql);
		metaData = rs.getMetaData();
		columnCount = metaData.getColumnCount();
		arrayResults.clear();
		addHeaders();
		addRows(rs);
		return arrayResults;
		}
		catch (Exception e){
			return null;
		}
		
	}
		
	private void addHeaders()
	{
		try
		{	
			ArrayList<String> arrayHeader = new ArrayList<String>();
			arrayHeader.clear();
			for (int i=1;i<columnCount+1;i++)
			{
				String cName = metaData.getColumnName(i);
				arrayHeader.add(cName);
			}
			arrayResults.add(arrayHeader);
		}
		catch (SQLException e)
		{
			return;
		}
	}
	
	private void addRows(ResultSet rs)
	{
		try
		{
			int rowCount = 0;
			while(rs.next())
			{
				ArrayList<String> arrayColumns = new ArrayList<String>();
				arrayColumns.clear();
				for (int i=1;i<columnCount+1;i++)
				{
					String s="";
					if (rs.getString(i)!=null)
						s = rs.getString(i).toString()+"";
					else
						s="Null";
					arrayColumns.add(s);
				}
				arrayResults.add(arrayColumns);
				rowCount++;				
			}
		}
		catch (Exception e)
		{
			return;
		}
	}
	
	private ResultSet QueryExecute(String Sql) {
		ResultSet rs = null;
		try 
		{
		//Class.forName(driver).newInstance();
		Class.forName(driver);
		Connection conn = DriverManager.getConnection(url,pUserName,pPassword);
		Statement stmt = conn.createStatement();
		rs = stmt.executeQuery(Sql);
		
		}
		catch (Exception e) {e.printStackTrace();}
		//catch (ClassNotFoundException e)	{e.printStackTrace();  }
		//catch (SQLException e2)				{e2.printStackTrace(); }

		return rs;
	}

	public Integer ExecuteNonQuery(String Sql) {
		ResultSet rs = null;
		try 
		{
		//Class.forName(driver).newInstance();
		Class.forName(driver);
		Connection conn = DriverManager.getConnection(url,pUserName,pPassword);
		Statement stmt = conn.createStatement();
		return stmt.executeUpdate(Sql);
		}
		catch (Exception e) {e.printStackTrace();}
		//catch (ClassNotFoundException e)	{e.printStackTrace();  }
		//catch (SQLException e2)				{e2.printStackTrace(); }

		return -1;
	}
	
	public ArrayList<ArrayList<String>> TableList() {
		ArrayList<ArrayList<String>> rs =  new  ArrayList<ArrayList<String>>();
		try {				
			rs = Query("SHOW TABLES");
		} catch (Exception e) {
			//Toast.makeText(this, "ERROR :" + e.toString(), Toast.LENGTH_LONG).show();
			return null;
		}
		return rs;
	}
	 
	/*
	private boolean InternetControl() {
		ConnectivityManager manager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
		if (manager.getActiveNetworkInfo() != null
				&& manager.getActiveNetworkInfo().isAvailable()
				&& manager.getActiveNetworkInfo().isConnected()) {
			return true;
		} else {
			return false;
		}
	}
	*/
	
	
}
